<template>
  <main>
    <mt-page-title :link-to="{ name: 'profil-dashboard-corps', params: { profil: 'admin' } }" link-text="Annuler">
      <h1 class="has-text-weight-bold is-size-3">Modification d'une catégorie</h1>
    </mt-page-title>
    <form @submit.prevent="submit">
      <mt-champs-form-corps :corp="corp" />
      <div class="columns is-centered">
        <b-button type="is-primary" native-type="submit">
          Enregistrer les modifications
        </b-button>
      </div>
    </form>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtChampsFormCorps from '~/components/dashboard/corps/champs-form-corps';
import newCorps from '~/components/mixins/corpsMixin';

export default {
  layout: 'container-small',
  components: {
    MtPageTitle,
    MtChampsFormCorps,
  },
  async asyncData(context) {
    const corp = Object.assign(newCorps(), await context.$api.corps.get(context.params.id));
    return {
      corp,
    };
  },
  methods: {
    async submit() {
      try {
        await this.$api.corps.put(this.corp.id, this.corp);
        this.$router.push({ name: 'profil-dashboard-corps', params: { profil: 'admin' } });
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss"></style>
